try {
        var dllPath = System.Gadget.path + "\\bin\\ScreenUploader.dll";
        builder = new GadgetBuilder();

        builder.Initialize();

        capture = builder.LoadType( dllPath, "Capture.ScreenCapture");
        timeoutId = -1;
        uploader = null;

        if ( capture == null ) {
           error = Object();
           error.name = "ActiveX Error";
           error.message = "Error: Can not load ActiveX component ScreenUploader.dll/Gadget.Interop.dll";
           throw error;
        }
}
catch ( e ) {
          reportError(e);
}


function getFormat() {
  var f = System.Gadget.Settings.readString("format");
  if ( f == "" ) {
       f = "jpg";
  }
  return f;
}

function getImagePath() {
  return System.Gadget.path + "\\screen." + getFormat();
}

function onShowFlyout() {}
function onHideFlyout() {}

function onDocked() {
//  setFlyout(false);
}
function onUnDocked() {
//  setFlyout(true);
}

function setFlyout( b ) { System.Gadget.Flyout.show = b; }
function flyout() { System.Gadget.Flyout.show = !System.Gadget.Flyout.show; }
function flyoutLoad() { updateLCD(); }

/**
* This method is called once, when gadet.html loaded.
*/
function initGadget() {

    System.Gadget.Flyout.file = "flyout.html";
    System.Gadget.Flyout.onShow = onShowFlyout;
    System.Gadget.Flyout.onHide = onHideFlyout;

    System.Gadget.Flyout.show = false;

    System.Gadget.onDock = onDocked;
    System.Gadget.onUndock = onUnDocked;

//    capture.erase( getImagePath() );

    self.focus;
    document.body.focus();

    System.Gadget.settingsUI = "settings.html";
    //System.Gadget.onSettingsClosed = SettingsClosed;

}

/**
* Gadget.html unloaded
*/
function unload() {
//  window.open("unloaded"); // TODO DELME
         builder.UnloadType( capture );
         capture = null;
}

function reportError( e ) {
  window.open( System.Gadget.path + "\\error.html?name=" + escape(e.name )+ "&message=" + escape(e.message) );
}

function checkUpload() {

  if ( !uploader.inProgress() ) {

    // upload finished

    try {
          clearTimeout( timeoutId );
          
          var lnk = document.getElementById("linkLbl");

          var ureslt = uploader.GetResult();

          if ( ureslt != null && ureslt != "" ) {

             lnk.href = ureslt;
             System.Sound.playSound( "../snd/stop.wav" );

             lnk.innerText = "Uploaded screenshot";

             capture.setClipboard( lnk.href );
//             window.open( lnk.href );

             if ( uploader.AutoIncrement ) {
                var idx = uploader.Index +1;
                System.Gadget.Settings.write("incIdx", idx );
             }

          }
          else {
               lnk.innerText = "Error";
               lnk.href = "#";
          }

          uploader = null;
    }
    catch( e ) {
        lnk.innerText = e.name;
        lnk.href = "http://" + e.message;
    }
    finally {
        var lcdim = document.getElementById("lcdImage");
        lcdim.src = "../images/blank.png";
    }
  }

}

function doUpload() {

    try {

        var lnk = document.getElementById("linkLbl");

        var umethod = System.Gadget.Settings.readString("uploader");

        if ( umethod != "http" && umethod != "ftp" ) {
           umethod = "http";
        }

        uploader = capture.createUploader( umethod );

        if ( umethod == "ftp" ) {
          uploader.Host          = System.Gadget.Settings.readString("ftphost");
          uploader.Port          = System.Gadget.Settings.read("ftpport");
          uploader.User          = System.Gadget.Settings.readString("username");
          uploader.Pass          = System.Gadget.Settings.readString("password");
          uploader.Dir           = System.Gadget.Settings.readString("dir");
          uploader.Link          = System.Gadget.Settings.readString("link");
          uploader.AutoIncrement = System.Gadget.Settings.readString("ainc") == "true";
          uploader.Index         = System.Gadget.Settings.read("incIdx");
          uploader.OpenBrowser   = true;
        }
        else { // http
             uploader.Public = false;
             uploader.OpenBrowser   = true;
        }

        // non blocking method
        var ureslt = uploader.BeginUpload( getImagePath() );

        if ( !ureslt) {
           lnk.innerText = "Already in progress";
           lnk.href = "#";
           return; // already progress
        }

        if ( timeoutId != -1 ) clearTimeout( timeoutId );
        timeoutId = setInterval( "checkUpload()", 400 );

    }
    catch(e) {
             lnk.innerText = e.name;
             lnk.href = "http://" + e.message;
    }

}

function upload() {

         var lnk = document.getElementById("linkLbl");

         if ( uploader != null ) {
           // inprogress
           lnk.innerText = "Already in progress";
           return;
         }

         if ( ! capture.isExists( getImagePath() ) ) {
       	      lnk.innerText = "No picture";
       	      lnk.href = "#";
              return;
         }

         lnk.innerText = "Pleasa wait..";

         var lcdim = document.getElementById("lcdImage");
         lcdim.src = "../images/progress.gif";
    	 lcdim.width = 128;
    	 lcdim.height = 96;

         doUpload();
}

function updateLCD() {

    var lcdim = document.getElementById("lcdImage");

    if ( ! capture.isExists( getImagePath() ) ) {
       lcdim.width = 128;
       lcdim.height = 96;
       lcdim.src = "#";
       lcdim.src = "../images/blank.png";
       return;
    }

    var w = capture.getImageFileWidth( getImagePath() );
    var h = capture.getImageFileHeight( getImagePath() );

    if ( w >= h ) {
       h = 128 * h / w;
       w = 128;
    }
    if ( w < h || h > 96 ) {
         w = 96 * w / h;
         h = 96;
    }

    lcdim.width = w;
    lcdim.height = h;
    lcdim.src = "../images/blank.png";
    lcdim.src = getImagePath();
}

function saveShot( captureType ) {
         System.Sound.playSound( "../snd/start.wav" )
         return capture.Capture( captureType, getImagePath() );
}

function save() {
      if ( capture.isExists( getImagePath() ) ) {
         capture.SaveFileDialog( getImagePath(), System.Gadget.path, getFormat() );
      }
      else {
           var lnk = document.getElementById("linkLbl");
       	   lnk.innerText = "No picture";
       	   lnk.href = "#";
      }
}

function showText(tid) {
  
        self.focus;
        document.body.focus();

	if ( tid != "empty" ) {
		document.getElementById("empty").style.visibility = "hidden";
	}
	document.getElementById(tid).style.visibility = "visible";
//	document.getElementById(tid).style.backgroundColor = "#000000";
}


function hideText(tid) {
	document.getElementById(tid).style.visibility = "hidden";
//	document.getElementById(tid).style.backgroundColor = "transparent";
	if ( tid != "empty" ) {
		document.getElementById("empty").style.visibility = "visible";
	}
}

function btnDown( btn ) {
        System.Sound.playSound( "../snd/beep.wav" )
	document.getElementById(btn).src = "images/buttondown.png";
}


function btnUp( btn ) {
	document.getElementById(btn).src = "images/button.png";
}

function about() {
         window.open( System.Gadget.path + "\\about.html" );
}

function edit() {
         if ( capture.isExists( getImagePath() ) ) {
            System.Shell.execute( 'mspaint', '"'+ getImagePath() + '"' );
         }
         else {
                 var lnk = document.getElementById("linkLbl");
                 lnk.innerText = "No picture";
                 lnk.href = "#"
         }
}